#import "MyController.h"

@implementation MyController

- (id) init {
	self = [super init];
	if (self != nil) {
		days = [[NSMutableArray alloc]init];
	}
	return self;
}


- (NSMutableArray *) days
{
	return days;
}
- (void) setDays: (NSArray *)newDays
{
	[days setArray:newDays];
}

-(IBAction)save:(id)sender
{
	NSSavePanel *savePanel = [NSSavePanel savePanel];
	SEL sel = @selector(savePanelDidEnd:returnCode:contextInfo:);
	[savePanel beginSheetForDirectory:@"~/Documents" file:@"menu.items" modalForWindow:[lessonTable window] modalDelegate:self didEndSelector:sel contextInfo:nil];
}

-(void)savePanelDidEnd:(NSSavePanel *)sheet
			returnCode:(int)returnCode
		   contextInfo:(void *)context
{
	if(returnCode == NSOKButton){
		[NSArchiver archiveRootObject:days toFile:[sheet filename]];
	}
}

-(IBAction)load:(id)sender
{
	NSOpenPanel *openPanel = [NSOpenPanel openPanel];
	SEL sel = @selector(openPanelDidEnd:returnCode:contextInfo:);
	[openPanel beginSheetForDirectory:@"~/Documents" file:nil types:nil modalForWindow:[lessonTable window] modalDelegate:self didEndSelector:sel contextInfo:nil];
}

-(void)openPanelDidEnd:(NSOpenPanel *)sheet
returnCode: (int)returnCode contextInfo:(void *)contextInfo
{
	if (returnCode == NSOKButton) {
		NSMutableArray *array;
		array = [NSUnarchiver unarchiveObjectWithFile:[sheet filename]];
		[self setDays:array];
	}
}


//SORTING TABLES

-(IBAction)moveLessonUp:(id)sender
{
	unsigned int currentIndex = [lessonArrayController selectionIndex];
	if (currentIndex) {
		NSArray *array = [NSArray arrayWithArray:[lessonArrayController selectedObjects]];
		[lessonArrayController removeObjectAtArrangedObjectIndex:currentIndex];
		[lessonArrayController insertObject:[array objectAtIndex:0] atArrangedObjectIndex:currentIndex-1];
		
	}	
}

-(IBAction)moveLessonDown:(id)sender
{
	unsigned int currentIndex = [lessonArrayController selectionIndex];
	unsigned int maxIndex = [lessonCounter intValue]-1;
		if (currentIndex != maxIndex) {
		NSArray *array = [NSArray arrayWithArray:[lessonArrayController selectedObjects]];
		[lessonArrayController removeObjectAtArrangedObjectIndex:currentIndex];
		[lessonArrayController insertObject:[array objectAtIndex:0] atArrangedObjectIndex:currentIndex+1];		
	}
}

-(IBAction)moveDayUp:(id)sender
{
	unsigned int currentIndex = [dayArrayController selectionIndex];
	if (currentIndex) {
		NSArray *array = [NSArray arrayWithArray:[dayArrayController selectedObjects]];
		[dayArrayController removeObjectAtArrangedObjectIndex:currentIndex];
		[lessonArrayController insertObject:[array objectAtIndex:0] atArrangedObjectIndex:currentIndex-1];
	}
}

-(IBAction)moveDayDown:(id)sender
{
	unsigned int currentIndex = [dayArrayController selectionIndex];
	unsigned int maxIndex = [dayCounter intValue]-1;
	if (currentIndex != maxIndex) {
		NSArray *array = [NSArray arrayWithArray:[dayArrayController selectedObjects]];
		[dayArrayController removeObjectAtArrangedObjectIndex:currentIndex];
		NSLog(@"%i",currentIndex);
		[lessonArrayController insertObject:[array objectAtIndex:0] atArrangedObjectIndex:currentIndex+1];
	}
}

//END SORTING TABLES

-(void) dealloc {
	[days release];
	[super dealloc];
}

@end
